summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author Dmitrii Sosedov <dmitrii@sosedov.org>2014-06-06 08:06:12 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2014-06-12 06:51:38 +0700
commit2d7548b781a70e0cbd4614c966ae9da5a832a1e1 (patch)
treeb06eb659db9a090564ab4fcefc4d98cdc4937905 /development
parent832169027772a2800e8b4ad5e137cb96595a6568 (diff)
downloadslackbuilds-2d7548b781a70e0cbd4614c966ae9da5a832a1e1.tar.gz
slackbuilds-2d7548b781a70e0cbd4614c966ae9da5a832a1e1.tar.xz
development/rust: Added (a safe, concurrent, practical language).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/rust/README22
-rw-r--r--development/rust/rust.SlackBuild92
-rw-r--r--development/rust/rust.info10
-rw-r--r--development/rust/slack-desc19
4 files changed, 143 insertions, 0 deletions
diff --git a/development/rust/README b/development/rust/README
new file mode 100644
index 0000000000..f50804cae9
--- /dev/null
+++ b/development/rust/README
@@ -0,0 +1,22 @@
+Rust
+
+Rust is a curly-brace, block-structured expression language. It visually resembles the C language family,
+but differs significantly in syntactic and semantic details.
+
+Its design is oriented toward concerns of "programming in the large", that is, of creating and
+maintaining boundaries - both abstract and operational - that preserve large-system integrity,
+availability and concurrency.
+
+It supports a mixture of imperative procedural, concurrent actor, object-oriented and pure functional styles.
+Rust also supports generic programming and metaprogramming, in both static and dynamic styles.
+
+A short summary of features:
+
+Type system: static, nominal, linear, algebraic, locally inferred
+Memory safety: no null or dangling pointers, no buffer overflows
+Concurrency: lightweight tasks with message passing, no shared memory
+Generics: type parameterization with type classes
+Exception handling: unrecoverable unwinding with task isolation
+Memory model: optional task-local GC, safe pointer types with region analysis
+Compilation model: ahead-of-time, C/C++ compatible
+License: dual MIT / Apache 2
diff --git a/development/rust/rust.SlackBuild b/development/rust/rust.SlackBuild
new file mode 100644
index 0000000000..5d4d77bd72
--- /dev/null
+++ b/development/rust/rust.SlackBuild
@@ -0,0 +1,92 @@
+#!/bin/sh
+
+# Slackware build script for rust
+
+# Copyright 2014 Dmitrii Sosedov, United States
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=rust
+VERSION=${VERSION:-0.10}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $PKG/usr $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM\-$VERSION\-$ARCH\-unknown-linux-gnu.tar.gz
+cd $PRGNAM-$VERSION-$ARCH-unknown-linux-gnu
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cp -r bin $PKG/usr/bin
+cp -r lib $PKG/usr/lib${LIBDIRSUFFIX}
+cp -r share $PKG/usr/share
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mv $PKG/usr/share/man $PKG/usr/
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/share/doc/$PRGNAM-$VERSION
+cp -a COPYRIGHT LICENSE-APACHE LICENSE-MIT README.md $PKG/usr/share/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/share/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+cat $CWD/$PRGNAM.info > $PKG/usr/share/doc/$PRGNAM-$VERSION/$PRGNAM.info
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/rust/rust.info b/development/rust/rust.info
new file mode 100644
index 0000000000..c4527e8a0b
--- /dev/null
+++ b/development/rust/rust.info
@@ -0,0 +1,10 @@
+PRGNAM="rust"
+VERSION="0.10"
+HOMEPAGE="http://www.rust-lang.org"
+DOWNLOAD="http://static.rust-lang.org/dist/rust-0.10-i686-unknown-linux-gnu.tar.gz"
+MD5SUM="a1d9980d5530a89476acb2824b0239e8"
+DOWNLOAD_x86_64="http://static.rust-lang.org/dist/rust-0.10-x86_64-unknown-linux-gnu.tar.gz"
+MD5SUM_x86_64="5a494447db1fd644e5b1ff65190f73ea"
+REQUIRES=""
+MAINTAINER="Dmitrii Sosedov"
+EMAIL="dmitrii@sosedov.org" \ No newline at end of file
diff --git a/development/rust/slack-desc b/development/rust/slack-desc
new file mode 100644
index 0000000000..eee1460570
--- /dev/null
+++ b/development/rust/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+rust: rust (a safe, concurrent, practical language)
+rust:
+rust: Rust is a curly-brace, block-structured expression language.
+rust: Its design is oriented toward concerns of "programming in the large",
+rust: that is, of creating and maintaining boundaries - both abstract and
+rust: operational - that preserve large-system integrity, availability and
+rust: concurrency.
+rust:
+rust: Homepage: http://rust-lang.org
+rust: Release date: April 3, 2014
+rust: \ No newline at end of file